The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Types | Public Member Functions | List of all members
RtMidiIn Class Reference

A realtime MIDI input class. More...

`#include <RtMidi.h>`

Inheritance diagram for RtMidiIn:

## Public Types
typedef void(* | RtMidiCallback) (double timeStamp, std::vector< unsigned char > *message, void *userData)
| User callback function type definition.
Public Types inherited from RtMidi
enum | Api { UNSPECIFIED , MACOSX_CORE , LINUX_ALSA , UNIX_JACK , WINDOWS_MM , RTMIDI_DUMMY , WEB_MIDI_API , WINDOWS_UWP , ANDROID_AMIDI , NUM_APIS }
| MIDI API specifier arguments. More...

## Public Member Functions
| RtMidiIn (RtMidi::Api api=UNSPECIFIED, const std::string &clientName="RtMidi Input Client", unsigned int queueSizeLimit=100)
| Default constructor that allows an optional api, client name and queue size.
| ~RtMidiIn (void) throw ()
| If a MIDI connection is still open, it will be closed by the destructor.
RtMidi::Api | getCurrentApi (void) throw ()
| Returns the MIDI API specifier for the current instance of RtMidiIn.
void | openPort (unsigned int portNumber=0, const std::string &portName=std::string("RtMidi Input"))
| Open a MIDI input connection given by enumeration number.
void | openVirtualPort (const std::string &portName=std::string("RtMidi Input"))
| Create a virtual input port, with optional name, to allow software connections (OS X, JACK and ALSA only).
void | setCallback (RtMidiCallback callback, void *userData=0)
| Set a callback function to be invoked for incoming MIDI messages.
void | cancelCallback ()
| Cancel use of the current callback function (if one exists).
void | closePort (void)
| Close an open MIDI connection (if one exists).
virtual bool | isPortOpen () const
| Returns true if a port is open and false if not.
unsigned int | getPortCount ()
| Return the number of available MIDI input ports.
std::string | getPortName (unsigned int portNumber=0)
| Return a string identifier for the specified MIDI input port number.
void | ignoreTypes (bool midiSysex=true, bool midiTime=true, bool midiSense=true)
| Specify whether certain MIDI message types should be queued or ignored during input.
double | getMessage (std::vector< unsigned char > *message)
| Fill the user-provided vector with the data bytes for the next available MIDI message in the input queue and return the event delta-time in seconds.
virtual void | setErrorCallback (RtMidiErrorCallback errorCallback=NULL, void *userData=0)
| Set an error callback function to be invoked when an error has occurred.
virtual void | setBufferSize (unsigned int size, unsigned int count)
| Set maximum expected incoming message size.
virtual void | openPort (unsigned int portNumber=0, const std::string &portName=std::string("RtMidi"))=0
| Pure virtual openPort() function.
virtual void | openVirtualPort (const std::string &portName=std::string("RtMidi"))=0
| Pure virtual openVirtualPort() function.
virtual unsigned int | getPortCount ()=0
| Pure virtual getPortCount() function.
virtual std::string | getPortName (unsigned int portNumber=0)=0
| Pure virtual getPortName() function.
virtual void | closePort (void)=0
| Pure virtual closePort() function.
virtual bool | isPortOpen (void) const =0
| Returns true if a port is open and false if not.
virtual void | setErrorCallback (RtMidiErrorCallback errorCallback=NULL, void *userData=0)=0
| Set an error callback function to be invoked when an error has occurred.

## Additional Inherited Members
Static Public Member Functions inherited from RtMidi
static std::string | getVersion (void) throw ()
| A static function to determine the current RtMidi version.
static void | getCompiledApi (std::vector< RtMidi::Api > &apis) throw ()
| A static function to determine the available compiled MIDI APIs.
static std::string | getApiName (RtMidi::Api api)
| Return the name of a specified compiled MIDI API.
static std::string | getApiDisplayName (RtMidi::Api api)
| Return the display name of a specified compiled MIDI API.
static RtMidi::Api | getCompiledApiByName (const std::string &name)
| Return the compiled MIDI API having the given name.

## Detailed Description

A realtime MIDI input class.

This class provides a common, platform-independent API for realtime MIDI input. It allows access to a single MIDI input port. Incoming MIDI messages are either saved to a queue for retrieval using the getMessage() function or immediately passed to a user-specified callback function. Create multiple instances of this class to connect to more than one MIDI device at the same time. With the OS-X, Linux ALSA, and JACK MIDI APIs, it is also possible to open a virtual input port to which other MIDI software clients can connect.

## Constructor & Destructor Documentation

## ◆ RtMidiIn()

RtMidiIn::RtMidiIn | ( | RtMidi::Api | api = `UNSPECIFIED`,
|  | const std::string & | clientName = `"RtMidi Input Client"`,
|  | unsigned int | queueSizeLimit = `100`
| ) |  |

Default constructor that allows an optional api, client name and queue size.

An exception will be thrown if a MIDI system initialization error occurs. The queue size defines the maximum number of messages that can be held in the MIDI queue (when not using a callback function). If the queue size limit is reached, incoming messages will be ignored.

If no API argument is specified and multiple API support has been compiled, the default order of use is ALSA, JACK (Linux) and CORE, JACK (OS-X).

Parameters

  api | An optional API id can be specified.
  clientName | An optional client name can be specified. This will be used to group the ports that are created by the application.
  queueSizeLimit | An optional size of the MIDI input queue can be specified.

## Member Function Documentation

## ◆ openPort()

void RtMidiIn::openPort | ( | unsigned int | portNumber = `0`,
|  | const std::string & | portName = `std::string( "RtMidi Input" )`
| ) |  |
| inlinevirtual

Open a MIDI input connection given by enumeration number.

Parameters

  portNumber | An optional port number greater than 0 can be specified. Otherwise, the default or first port found is opened.
  portName | An optional name for the application port that is used to connect to portId can be specified.

Implements RtMidi.

653{ rtapi_->openPort( portNumber, portName ); }

## ◆ openVirtualPort()

void RtMidiIn::openVirtualPort | ( | const std::string & | portName = `std::string( "RtMidi Input" )` | ) |
| inlinevirtual

Create a virtual input port, with optional name, to allow software connections (OS X, JACK and ALSA only).

This function creates a virtual MIDI input port to which other software applications can connect. This type of functionality is currently only supported by the Macintosh OS-X, any JACK, and Linux ALSA APIs (the function returns an error for the other APIs).

Parameters

  portName | An optional name for the application port that is used to connect to portId can be specified.

Implements RtMidi.

654{ rtapi_->openVirtualPort( portName ); }

## ◆ setCallback()

void RtMidiIn::setCallback | ( | RtMidiCallback | callback,
|  | void * | userData = `0`
| ) |  |
| inline

Set a callback function to be invoked for incoming MIDI messages.

The callback function will be called whenever an incoming MIDI message is received. While not absolutely necessary, it is best to set the callback function before opening a MIDI port to avoid leaving some messages in the queue.

Parameters

  callback | A callback function must be given.
  userData | Optionally, a pointer to additional data can be passed to the callback function whenever it is called.

657{ static_cast<MidiInApi *>(rtapi_)->setCallback( callback, userData ); }
RtMidiIn::setCallback
void setCallback(RtMidiCallback callback, void *userData=0)
Set a callback function to be invoked for incoming MIDI messages.
Definition RtMidi.h:657

## ◆ cancelCallback()

void RtMidiIn::cancelCallback | ( | void |  | ) |
| inline

Cancel use of the current callback function (if one exists).

Subsequent incoming MIDI messages will be written to the queue and can be retrieved with the getMessage function.

658{ static_cast<MidiInApi *>(rtapi_)->cancelCallback(); }
RtMidiIn::cancelCallback
void cancelCallback()
Cancel use of the current callback function (if one exists).
Definition RtMidi.h:658

## ◆ isPortOpen()

bool RtMidiIn::isPortOpen | ( | void |  | ) | const
| inlinevirtual

Returns true if a port is open and false if not.

Note that this only applies to connections made with the openPort() function, not to virtual ports.

Implements RtMidi.

656{ return rtapi_->isPortOpen(); }

## ◆ getPortCount()

unsigned int RtMidiIn::getPortCount | ( | void |  | ) |
| inlinevirtual

Return the number of available MIDI input ports.

Returns
  This function returns the number of MIDI ports of the selected API.

Implements RtMidi.

659{ return rtapi_->getPortCount(); }

## ◆ getPortName()

std::string RtMidiIn::getPortName | ( | unsigned int | portNumber = `0` | ) |
| inlinevirtual

Return a string identifier for the specified MIDI input port number.

Returns
  The name of the port with the given Id is returned.

Return values

  An | empty string is returned if an invalid port specifier is provided. User code should assume a UTF-8 encoding.

Implements RtMidi.

660{ return rtapi_->getPortName( portNumber ); }

## ◆ ignoreTypes()

void RtMidiIn::ignoreTypes | ( | bool | midiSysex = `true`,
|  | bool | midiTime = `true`,
|  | bool | midiSense = `true`
| ) |  |
| inline

Specify whether certain MIDI message types should be queued or ignored during input.

By default, MIDI timing and active sensing messages are ignored during message input because of their relative high data rates. MIDI sysex messages are ignored by default as well. Variable values of "true" imply that the respective message type will be ignored.

661{ static_cast<MidiInApi *>(rtapi_)->ignoreTypes( midiSysex, midiTime, midiSense ); }
RtMidiIn::ignoreTypes
void ignoreTypes(bool midiSysex=true, bool midiTime=true, bool midiSense=true)
Specify whether certain MIDI message types should be queued or ignored during input.
Definition RtMidi.h:661

## ◆ getMessage()

double RtMidiIn::getMessage | ( | std::vector< unsigned char > * | message | ) |
| inline

Fill the user-provided vector with the data bytes for the next available MIDI message in the input queue and return the event delta-time in seconds.

This function returns immediately whether a new message is available or not. A valid message is indicated by a non-zero vector size. An exception is thrown if an error occurs during message retrieval or an input connection was not previously established.

662{ return static_cast<MidiInApi *>(rtapi_)->getMessage( message ); }
RtMidiIn::getMessage
double getMessage(std::vector< unsigned char > *message)
Fill the user-provided vector with the data bytes for the next available MIDI message in the input qu...
Definition RtMidi.h:662

## ◆ setErrorCallback()

void RtMidiIn::setErrorCallback | ( | RtMidiErrorCallback | errorCallback = `NULL`,
|  | void * | userData = `0`
| ) |  |
| inlinevirtual

Set an error callback function to be invoked when an error has occurred.

The callback function will be called whenever an error has occurred. It is best to set the error callback function before opening a port.

Implements RtMidi.

663{ rtapi_->setErrorCallback(errorCallback, userData); }

## ◆ setBufferSize()

void RtMidiIn::setBufferSize | ( | unsigned int | size,
|  | unsigned int | count
| ) |  |
| inlinevirtual

Set maximum expected incoming message size.

For APIs that require manual buffer management, it can be useful to set the buffer size and buffer count when expecting to receive large SysEx messages. Note that currently this function has no effect when called after openPort(). The default buffer size is 1024 with a count of 4 buffers, which should be sufficient for most cases; as mentioned, this does not affect all API backends, since most either support dynamically scalable buffers or take care of buffer handling themselves. It is principally intended for users of the Windows MM backend who must support receiving especially large messages.

664{ static_cast<MidiInApi *>(rtapi_)->setBufferSize(size, count); }
RtMidiIn::setBufferSize
virtual void setBufferSize(unsigned int size, unsigned int count)
Set maximum expected incoming message size.
Definition RtMidi.h:664

The documentation for this class was generated from the following file:

- RtMidi.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.